Index: molecuilder/src/UIElements/TextUI/TextDialog.cpp
===================================================================
--- molecuilder/src/UIElements/TextUI/TextDialog.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
+++ molecuilder/src/UIElements/TextUI/TextDialog.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -0,0 +1,344 @@
+/*
+ * TextDialog.cpp
+ *
+ *  Created on: Jan 5, 2010
+ *      Author: crueger
+ */
+
+#include <iostream>
+
+#include <Descriptors/AtomDescriptor.hpp>
+#include <Descriptors/AtomIdDescriptor.hpp>
+#include <Descriptors/MoleculeDescriptor.hpp>
+#include <Descriptors/MoleculeIdDescriptor.hpp>
+#include "TextUI/TextDialog.hpp"
+
+#include "World.hpp"
+#include "periodentafel.hpp"
+#include "log.hpp"
+#include "verbose.hpp"
+
+#include "atom.hpp"
+#include "element.hpp"
+#include "molecule.hpp"
+#include "vector.hpp"
+
+using namespace std;
+
+
+TextDialog::TextDialog()
+{
+}
+
+TextDialog::~TextDialog()
+{
+}
+
+
+void TextDialog::queryEmpty(const char* title, string description){
+  registerQuery(new EmptyTextQuery(title,description));
+}
+
+void TextDialog::queryBoolean(const char* title, bool* target, string description){
+  registerQuery(new BooleanTextQuery(title,target,description));
+}
+
+void TextDialog::queryInt(const char* title, int* target, string description){
+  registerQuery(new IntTextQuery(title,target,description));
+}
+
+void TextDialog::queryDouble(const char* title, double* target, string description){
+  registerQuery(new DoubleTextQuery(title,target,description));
+}
+
+void TextDialog::queryString(const char* title, string* target, string description){
+  registerQuery(new StringTextQuery(title,target,description));
+}
+
+void TextDialog::queryAtom(const char* title, atom **target, string description) {
+  registerQuery(new AtomTextQuery(title,target,description));
+}
+
+void TextDialog::queryMolecule(const char* title, molecule **target, string description) {
+  registerQuery(new MoleculeTextQuery(title,target,description));
+}
+
+void TextDialog::queryVector(const char* title, Vector *target,const double *const cellSize, bool check, string description) {
+  registerQuery(new VectorTextQuery(title,target,cellSize,check,description));
+}
+
+void TextDialog::queryBox(const char* title,double ** const cellSize, string description) {
+  registerQuery(new BoxTextQuery(title,cellSize,description));
+}
+
+void TextDialog::queryElement(const char* title, const element **target, string description){
+  registerQuery(new ElementTextQuery(title,target,description));
+}
+
+/************************** Query Infrastructure ************************/
+
+TextDialog::EmptyTextQuery::EmptyTextQuery(string title, std::string _description) :
+    Dialog::EmptyQuery(title,_description)
+{}
+
+TextDialog::EmptyTextQuery::~EmptyTextQuery() {}
+
+bool TextDialog::EmptyTextQuery::handle() {
+  cout << "Message of " << getTitle() << ":\n" << getDescription() << "\n";
+  return true;
+}
+
+TextDialog::IntTextQuery::IntTextQuery(string title, int * _target, std::string _description) :
+    Dialog::IntQuery(title,_target,_description)
+{}
+
+TextDialog::IntTextQuery::~IntTextQuery() {}
+
+bool TextDialog::IntTextQuery::handle() {
+  bool badInput = false;
+  do{
+    badInput = false;
+    Log() << Verbose(0) << getTitle();
+    cin >> tmp;
+    if(cin.fail()){
+      badInput=true;
+      cin.clear();
+      cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
+      Log() << Verbose(0) << "Input was not a number!" << endl;
+    }
+  } while(badInput);
+  // clear the input buffer of anything still in the line
+  cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
+  return true;
+}
+
+TextDialog::BooleanTextQuery::BooleanTextQuery(string title, bool * _target, std::string _description) :
+    Dialog::BooleanQuery(title,_target,_description)
+{}
+
+TextDialog::BooleanTextQuery::~BooleanTextQuery() {}
+
+bool TextDialog::BooleanTextQuery::handle() {
+  bool badInput = false;
+  char input = ' ';
+  do{
+    badInput = false;
+    Log() << Verbose(0) << getTitle();
+    cin >> input;
+    if ((input == 'y' ) || (input == 'Y')) {
+      tmp = true;
+    } else if ((input == 'n' ) || (input == 'N')) {
+      tmp = false;
+    } else {
+      badInput=true;
+      cin.clear();
+      cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
+      Log() << Verbose(0) << "Input was not of [yYnN]!" << endl;
+    }
+  } while(badInput);
+  // clear the input buffer of anything still in the line
+  cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
+  return true;
+}
+
+TextDialog::StringTextQuery::StringTextQuery(string title,string *_target, std::string _description) :
+    Dialog::StringQuery(title,_target,_description)
+{}
+
+TextDialog::StringTextQuery::~StringTextQuery() {}
+
+bool TextDialog::StringTextQuery::handle() {
+  Log() << Verbose(0) << getTitle();
+  getline(cin,tmp);
+  return true;
+}
+
+TextDialog::DoubleTextQuery::DoubleTextQuery(string title,double *_target, std::string _description) :
+    Dialog::DoubleQuery(title,_target,_description)
+{}
+
+TextDialog::DoubleTextQuery::~DoubleTextQuery() {}
+
+bool TextDialog::DoubleTextQuery::handle() {
+  bool badInput = false;
+  do{
+    badInput = false;
+    Log() << Verbose(0) << getTitle();
+    cin >> tmp;
+    if(cin.fail()){
+      badInput = true;
+      cin.clear();
+      cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
+      Log() << Verbose(0) << "Input was not a number!" << endl;
+    }
+  }while(badInput);
+  cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
+  return true;
+}
+
+TextDialog::AtomTextQuery::AtomTextQuery(string title, atom **_target, std::string _description) :
+    Dialog::AtomQuery(title,_target,_description)
+{}
+
+TextDialog::AtomTextQuery::~AtomTextQuery() {}
+
+bool TextDialog::AtomTextQuery::handle() {
+  int idxOfAtom=0;
+  bool badInput = false;
+  do{
+    badInput = false;
+    Log() << Verbose(0) << getTitle();
+    cin >> idxOfAtom;
+    if(cin.fail()){
+      badInput = true;
+      cin.clear();
+      cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
+      Log() << Verbose(0) << "Input was not a number!" << endl;
+      continue;
+    }
+
+    tmp = World::getInstance().getAtom(AtomById(idxOfAtom));
+    if(!tmp && idxOfAtom!=-1){
+      Log() << Verbose(0) << "Invalid Atom Index" << endl;
+      badInput = true;
+    }
+
+  } while(badInput);
+  cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
+  return (idxOfAtom!=-1);
+}
+
+TextDialog::MoleculeTextQuery::MoleculeTextQuery(string title, molecule **_target, std::string _description) :
+    Dialog::MoleculeQuery(title,_target,_description)
+{}
+
+TextDialog::MoleculeTextQuery::~MoleculeTextQuery() {}
+
+bool TextDialog::MoleculeTextQuery::handle() {
+  int idxOfMol=0;
+  bool badInput = false;
+  do{
+    badInput = false;
+    Log() << Verbose(0) << getTitle();
+    cin >> idxOfMol;
+    if(cin.fail()){
+      badInput = true;
+      cin.clear();
+      cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
+      Log() << Verbose(0) << "Input was not a number!" << endl;
+      continue;
+    }
+
+    tmp = World::getInstance().getMolecule(MoleculeById(idxOfMol));
+    if(!tmp && idxOfMol!=-1){
+      Log() << Verbose(0) << "Invalid Molecule Index" << endl;
+      badInput = true;
+    }
+
+  } while(badInput);
+  cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
+  return (idxOfMol!=-1);
+}
+
+TextDialog::VectorTextQuery::VectorTextQuery(std::string title, Vector *_target, const double *const _cellSize, bool _check, std::string _description) :
+    Dialog::VectorQuery(title,_target,_cellSize,_check,_description)
+{}
+
+TextDialog::VectorTextQuery::~VectorTextQuery()
+{}
+
+bool TextDialog::VectorTextQuery::handle() {
+  Log() << Verbose(0) << getTitle();
+
+  char coords[3] = {'x','y','z'};
+  int j = -1;
+  for (int i=0;i<3;i++) {
+    j += i+1;
+    do {
+      Log() << Verbose(0) << coords[i] << "[0.." << cellSize[j] << "]: ";
+      cin >> (*tmp)[i];
+    } while ((((*tmp)[i] < 0) || ((*tmp)[i] >= cellSize[j])) && (check));
+  }
+  return true;
+}
+
+TextDialog::BoxTextQuery::BoxTextQuery(std::string title, double ** const _cellSize, std::string _description) :
+    Dialog::BoxQuery(title,_cellSize,_description)
+{}
+
+TextDialog::BoxTextQuery::~BoxTextQuery()
+{}
+
+bool TextDialog::BoxTextQuery::handle() {
+  Log() << Verbose(0) << getTitle();
+
+  std::string coords[6] = {"xx","xy","xz", "yy", "yz", "zz"};
+  for (int i=0;i<6;i++) {
+    Log() << Verbose(0) << coords[i] << ": ";
+    cin >> tmp[i];
+  }
+  return true;
+}
+
+TextDialog::ElementTextQuery::ElementTextQuery(std::string title, const element **target, std::string _description) :
+    Dialog::ElementQuery(title,target,_description)
+{}
+
+TextDialog::ElementTextQuery::~ElementTextQuery()
+{}
+
+bool TextDialog::ElementTextQuery::handle() {
+  bool badInput=false;
+  bool aborted = false;
+  do{
+    badInput = false;
+    Log() << Verbose(0) << getTitle();
+
+    // try to read as Atomic number
+    int Z;
+    cin >> Z;
+    if(!cin.fail()){
+      if(Z==-1){
+        aborted = true;
+      }
+      else{
+        tmp = World::getInstance().getPeriode()->FindElement(Z);
+        if(!tmp){
+          Log() << Verbose(0) << "No element with this atomic number!" << endl;
+          badInput = true;
+        }
+      }
+      continue;
+    }
+    else{
+      cin.clear();
+    }
+
+    // Try to read as shorthand
+    // the last buffer content was not removed, so we read the
+    // same thing again, this time as a string
+    string shorthand;
+    cin >> shorthand;
+    if(!cin.fail()){
+      if(shorthand.empty()){
+        aborted = true;
+      }
+      else{
+        tmp = World::getInstance().getPeriode()->FindElement(shorthand.c_str());
+        if(!tmp){
+          Log() << Verbose(0) << "No element with this shorthand!" << endl;
+          badInput = true;
+        }
+      }
+    }
+    else{
+      Log() << Verbose(0) << "Could not read input. Try Again." << endl;
+      cin.clear();
+      cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
+      badInput = true;
+    }
+
+  }while(badInput);
+  cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
+  return !aborted;
+}
Index: molecuilder/src/UIElements/TextUI/TextDialog.hpp
===================================================================
--- molecuilder/src/UIElements/TextUI/TextDialog.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
+++ molecuilder/src/UIElements/TextUI/TextDialog.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -0,0 +1,110 @@
+/*
+ * TextDialog.hpp
+ *
+ *  Created on: Jan 5, 2010
+ *      Author: crueger
+ */
+
+#ifndef TEXTDIALOG_HPP_
+#define TEXTDIALOG_HPP_
+
+#include <string>
+
+#include "Dialog.hpp"
+
+class atom;
+class element;
+class molecule;
+class Vector;
+
+class TextDialog : public Dialog
+{
+public:
+  TextDialog();
+  virtual ~TextDialog();
+
+  virtual void queryEmpty(const char *, std::string = "");
+  virtual void queryBoolean(const char *, bool *, std::string = "");
+  virtual void queryInt(const char *, int *, std::string = "");
+  virtual void queryString(const char*, std::string *, std::string = "");
+  virtual void queryDouble(const char*, double*, std::string = "");
+  virtual void queryAtom(const char*,atom**,std::string = "");
+  virtual void queryMolecule(const char*,molecule**,std::string = "");
+  virtual void queryVector(const char*,Vector *,const double * const,bool, std::string = "");
+  virtual void queryBox(const char*,double ** const, std::string = "");
+  virtual void queryElement(const char*,const element **, std::string = "");
+
+protected:
+  // specialized stuff for text queries
+  class EmptyTextQuery : public Dialog::EmptyQuery {
+  public:
+    EmptyTextQuery(std::string title, std::string _description = NULL);
+    virtual ~EmptyTextQuery();
+    virtual bool handle();
+  };
+
+  class BooleanTextQuery : public Dialog::BooleanQuery {
+  public:
+    BooleanTextQuery(std::string title, bool *_target, std::string _description = NULL);
+    virtual ~BooleanTextQuery();
+    virtual bool handle();
+  };
+
+  class IntTextQuery : public Dialog::IntQuery {
+  public:
+    IntTextQuery(std::string title, int *_target, std::string _description = NULL);
+    virtual ~IntTextQuery();
+    virtual bool handle();
+  };
+
+  class DoubleTextQuery : public Dialog::DoubleQuery {
+  public:
+    DoubleTextQuery(std::string title, double *_target, std::string _description = NULL);
+    virtual ~DoubleTextQuery();
+    virtual bool handle();
+  };
+
+  class StringTextQuery : public Dialog::StringQuery {
+  public:
+    StringTextQuery(std::string title, std::string *_target, std::string _description = NULL);
+    virtual ~StringTextQuery();
+    virtual bool handle();
+  };
+
+  class AtomTextQuery : public Dialog::AtomQuery {
+  public:
+    AtomTextQuery(std::string title, atom **_target, std::string _description = NULL);
+    virtual ~AtomTextQuery();
+    virtual bool handle();
+  };
+
+  class MoleculeTextQuery : public Dialog::MoleculeQuery {
+  public:
+    MoleculeTextQuery(std::string title, molecule **_target, std::string _description = NULL);
+    virtual ~MoleculeTextQuery();
+    virtual bool handle();
+  };
+
+  class VectorTextQuery : public Dialog::VectorQuery {
+  public:
+    VectorTextQuery(std::string title,Vector *_target,const double *const _cellSize,bool _check, std::string _description = NULL);
+    virtual ~VectorTextQuery();
+    virtual bool handle();
+  };
+
+  class BoxTextQuery : public Dialog::BoxQuery {
+  public:
+    BoxTextQuery(std::string title,double ** const _cellSize, std::string _description = NULL);
+    virtual ~BoxTextQuery();
+    virtual bool handle();
+  };
+
+  class ElementTextQuery : public Dialog::ElementQuery {
+  public:
+    ElementTextQuery(std::string title, const element **_target, std::string _description = NULL);
+    virtual ~ElementTextQuery();
+    virtual bool handle();
+  };
+};
+
+#endif /* TEXTDIALOG_HPP_ */
Index: molecuilder/src/UIElements/TextUI/TextStatusIndicator.cpp
===================================================================
--- molecuilder/src/UIElements/TextUI/TextStatusIndicator.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
+++ molecuilder/src/UIElements/TextUI/TextStatusIndicator.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -0,0 +1,56 @@
+/*
+ * TextStatusIndicator.cpp
+ *
+ *  Created on: Feb 18, 2010
+ *      Author: crueger
+ */
+
+#include "TextUI/TextStatusIndicator.hpp"
+
+#include <iostream>
+
+#include "Actions/Process.hpp"
+
+using namespace std;
+
+TextStatusIndicator::TextStatusIndicator()
+{
+  Process::AddObserver(this);
+}
+
+TextStatusIndicator::~TextStatusIndicator()
+{
+  Process::RemoveObserver(this);
+}
+
+void TextStatusIndicator::update(Observable *subject){
+  Process *proc;
+  // we are only observing Processes
+  if((proc=dynamic_cast<Process*>(subject))){
+    // see what kind of progress we have to display
+    if(proc->getMaxSteps()>0){
+      if(!proc->doesStop()){
+        cout << "Busy (" << proc->getName() << ") ";
+        // we can show a percentage done
+        cout << (int)proc->getDoneRatio() << "% done" << endl;
+      }
+    }
+    else{
+      // we only show some kind of busy animation
+      if(proc->doesStart()){
+        cout << "Busy (" << proc->getName() << ")";
+      }
+      if(!proc->doesStop()){
+        cout << ".";
+      }
+      else {
+        cout << endl;
+      }
+    }
+  }
+}
+
+void TextStatusIndicator::subjectKilled(Observable *subject){
+
+}
+
Index: molecuilder/src/UIElements/TextUI/TextStatusIndicator.hpp
===================================================================
--- molecuilder/src/UIElements/TextUI/TextStatusIndicator.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
+++ molecuilder/src/UIElements/TextUI/TextStatusIndicator.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -0,0 +1,26 @@
+/*
+ * TextStatusIndicator.hpp
+ *
+ *  Created on: Feb 18, 2010
+ *      Author: crueger
+ */
+
+#ifndef TEXTSTATUSINDICATOR_HPP_
+#define TEXTSTATUSINDICATOR_HPP_
+
+#include "Patterns/Observer.hpp"
+
+class TextStatusIndicator : public Observer
+{
+public:
+  TextStatusIndicator();
+  virtual ~TextStatusIndicator();
+
+  void update(Observable *subject);
+  void subjectKilled(Observable *subject);
+
+private:
+
+};
+
+#endif /* TEXTSTATUSINDICATOR_HPP_ */
Index: molecuilder/src/UIElements/TextUI/TextUIFactory.hpp
===================================================================
--- molecuilder/src/UIElements/TextUI/TextUIFactory.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
+++ molecuilder/src/UIElements/TextUI/TextUIFactory.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -0,0 +1,27 @@
+/*
+ * TextUIFactory.h
+ *
+ *  Created on: Jan 5, 2010
+ *      Author: crueger
+ */
+
+#ifndef TEXTUIFACTORY_HPP_
+#define TEXTUIFACTORY_HPP_
+
+#include "UIFactory.hpp"
+
+class TextUIFactory : public UIFactory
+{
+friend class UIFactory;
+
+public:
+  virtual ~TextUIFactory();
+
+  virtual Dialog* makeDialog();
+  virtual MainWindow* makeMainWindow();
+
+protected:
+  TextUIFactory();
+};
+
+#endif /* TEXTUIFACTORY_HPP_ */
Index: molecuilder/src/UIElements/TextUI/TextWindow.cpp
===================================================================
--- molecuilder/src/UIElements/TextUI/TextWindow.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
+++ molecuilder/src/UIElements/TextUI/TextWindow.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -0,0 +1,158 @@
+/*
+ * TextWindow.cpp
+ *
+ *  Created on: Jan 7, 2010
+ *      Author: crueger
+ */
+
+#include "TextUI/TextWindow.hpp"
+
+#include <boost/bind.hpp>
+
+
+// TODO: When done with refactoring most of these wont be needed anymore
+#include "analysis_correlation.hpp"
+#include "atom.hpp"
+#include "bond.hpp"
+#include "bondgraph.hpp"
+#include "boundary.hpp"
+#include "config.hpp"
+#include "element.hpp"
+#include "ellipsoid.hpp"
+#include "helpers.hpp"
+#include "leastsquaremin.hpp"
+#include "linkedcell.hpp"
+#include "log.hpp"
+#include "memoryusageobserver.hpp"
+#include "molecule.hpp"
+#include "periodentafel.hpp"
+#include "World.hpp"
+
+#include "Legacy/oldmenu.hpp"
+
+#include "Menu/Menu.hpp"
+#include "Menu/TextMenu.hpp"
+#include "Menu/ActionMenuItem.hpp"
+#include "Menu/SeperatorItem.hpp"
+#include "Menu/DisplayMenuItem.hpp"
+#include "Menu/SubMenuItem.hpp"
+#include "TextUI/TextStatusIndicator.hpp"
+#include "Actions/MethodAction.hpp"
+#include "Actions/MoleculeAction/ChangeNameAction.hpp"
+#include "Actions/ErrorAction.hpp"
+#include "Actions/ActionRegistry.hpp"
+#include "Views/StreamStringView.hpp"
+#include "Views/MethodStringView.hpp"
+
+#include <iostream>
+
+using namespace std;
+
+// TODO: see what code can be moved to a base class for Graphic and Text Windows
+TextWindow::TextWindow()
+{
+  MoleculeListClass *molecules = World::getInstance().getMolecules();
+  config *configuration = World::getInstance().getConfig();
+  periodentafel *periode = World::getInstance().getPeriode();
+  char *ConfigFileName = NULL;
+  old_menu = new oldmenu;
+
+  // build the main menu
+  main_menu = new TextMenu(Log() << Verbose(0), "Main Menu");
+
+  moleculeView = new StreamStringView(boost::bind(&MoleculeListClass::Enumerate,molecules,_1));
+  new DisplayMenuItem(main_menu,moleculeView,"Molecule List");
+
+  new SeperatorItem(main_menu);
+
+  Action* undoAction = ActionRegistry::getInstance().getActionByName("Undo");
+  new ActionMenuItem('u',"Undo last operation",main_menu,undoAction);
+
+  Action* redoAction = ActionRegistry::getInstance().getActionByName("Redo");
+  new ActionMenuItem('r',"Redo last operation",main_menu,redoAction);
+
+  new SeperatorItem(main_menu);
+
+  Action *setMoleculeAction = new MethodAction("setMoleculeAction",boost::bind(&MoleculeListClass::flipChosen,molecules));
+  new ActionMenuItem('a',"set molecule (in)active",main_menu,setMoleculeAction);
+
+  TextMenu *editMoleculesMenu = new TextMenu(Log() << Verbose(0), "Edit Molecules");
+  new SubMenuItem('e',"edit molecules (load, parse, save)",main_menu,editMoleculesMenu);
+
+  Action *manipulateMoleculeAction = new MethodAction("manipulateMoleculeAction",boost::bind(&oldmenu::ManipulateMolecules,old_menu,periode, molecules, configuration));
+  new ActionMenuItem('g',"globally manipulate atoms in molecule",main_menu,manipulateMoleculeAction);
+
+  Action *mergeMoleculeAction = new MethodAction("mergeMoleculeAction",boost::bind(&oldmenu::MergeMolecules,old_menu,periode, molecules));
+  new ActionMenuItem('M',"Merge molecules",main_menu,mergeMoleculeAction);
+
+  Action *manipulateAtomsAction = new MethodAction("manipulateAtomsAction",boost::bind(&oldmenu::ManipulateAtoms,old_menu,periode, molecules, configuration));
+  new ActionMenuItem('m',"manipulate atoms",main_menu,manipulateAtomsAction);
+
+  new SeperatorItem(main_menu);
+
+  Action *editConfigAction = new MethodAction("editConfigAction",boost::bind(&config::Edit,configuration));
+  new ActionMenuItem('c',"edit the current configuration",main_menu,editConfigAction);
+
+  new SeperatorItem(main_menu);
+
+  Action *saveConfigAction = new MethodAction("saveConfigAction",boost::bind(&config::SaveAll,configuration, ConfigFileName, periode, molecules));
+  new ActionMenuItem('s',"save current setup to config file",main_menu,saveConfigAction);
+
+  Action *doTestAction = new MethodAction("doTestAction",boost::bind(&oldmenu::testroutine,old_menu,molecules));
+  new ActionMenuItem('T',"call the current test routine",main_menu,doTestAction);
+
+  quitAction = new MethodAction("quitAction",boost::bind(&TextMenu::doQuit,main_menu),false);
+  new ActionMenuItem('q',"quit",main_menu,quitAction);
+
+  // call all functions used to build the submenus
+
+  populateEditMoleculesMenu(editMoleculesMenu);
+
+  Action *returnFromEditMoleculeAction = new TextMenu::LeaveAction(editMoleculesMenu);
+  MenuItem *returnItem = new ActionMenuItem('q',"return to Main menu",editMoleculesMenu,returnFromEditMoleculeAction);
+
+  editMoleculesMenu->addDefault(returnItem);
+
+  // Add status indicators etc...
+
+  statusIndicator = new TextStatusIndicator();
+}
+
+TextWindow::~TextWindow()
+{
+  delete old_menu;
+  delete quitAction;
+  delete moleculeView;
+  delete statusIndicator;
+  delete main_menu;
+}
+
+void TextWindow::display() {
+  main_menu->display();
+}
+
+void TextWindow::populateEditMoleculesMenu(Menu* editMoleculesMenu)
+{
+  MoleculeListClass *molecules = World::getInstance().getMolecules();
+  periodentafel *periode = World::getInstance().getPeriode();
+
+  // build the EditMoleculesMenu
+  Action *createMoleculeAction = new MethodAction("createMoleculeAction",boost::bind(&MoleculeListClass::createNewMolecule,molecules,periode));
+  new ActionMenuItem('c',"create new molecule",editMoleculesMenu,createMoleculeAction);
+
+  Action *loadMoleculeAction = new MethodAction("loadMoleculeAction",boost::bind(&MoleculeListClass::loadFromXYZ,molecules,periode));
+  new ActionMenuItem('l',"load molecule from xyz file",editMoleculesMenu,loadMoleculeAction);
+
+  Action *changeFilenameAction = new MoleculeChangeNameAction();
+  new ActionMenuItem('n',"change molecule's name",editMoleculesMenu,changeFilenameAction);
+
+  Action *giveFilenameAction = new MethodAction("giveFilenameAction",boost::bind(&MoleculeListClass::setMoleculeFilename,molecules));
+  new ActionMenuItem('N',"give molecules filename",editMoleculesMenu,giveFilenameAction);
+
+  Action *parseAtomsAction = new MethodAction("parseAtomsAction",boost::bind(&MoleculeListClass::parseXYZIntoMolecule,molecules));
+  new ActionMenuItem('p',"parse atoms in xyz file into molecule",editMoleculesMenu,parseAtomsAction);
+
+  Action *eraseMoleculeAction = new MethodAction("eraseMoleculeAction",boost::bind(&MoleculeListClass::eraseMolecule,molecules));
+  new ActionMenuItem('r',"remove a molecule",editMoleculesMenu,eraseMoleculeAction);
+
+}
Index: molecuilder/src/UIElements/TextUI/TextWindow.hpp
===================================================================
--- molecuilder/src/UIElements/TextUI/TextWindow.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
+++ molecuilder/src/UIElements/TextUI/TextWindow.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -0,0 +1,43 @@
+/*
+ * TextWindow.hpp
+ *
+ *  Created on: Jan 7, 2010
+ *      Author: crueger
+ */
+
+#ifndef TEXTWINDOW_HPP_
+#define TEXTWINDOW_HPP_
+
+#include "MainWindow.hpp"
+
+class TextMenu;
+class Action;
+class oldmenu;
+class StringView;
+class TextStatusIndicator;
+
+
+class TextWindow : public MainWindow
+{
+public:
+  TextWindow();
+  virtual ~TextWindow();
+
+  virtual void display();
+private:
+  // populaters
+  void populateEditMoleculesMenu(Menu* editMoleculesMenu);
+
+  TextMenu *main_menu;
+
+  // some actions only needed in textMenus
+  Action *quitAction;
+  // all views that are contained in the main Menu
+  StringView *moleculeView;
+  TextStatusIndicator *statusIndicator;
+
+  // This class still contains a lot of scattered functionality
+  oldmenu *old_menu;
+};
+
+#endif /* TEXTWINDOW_HPP_ */
Index: molecuilder/src/UIElements/UIFactory.cpp
===================================================================
--- molecuilder/src/UIElements/UIFactory.cpp	(revision 3561800616d100e40c39e5a93b9765d260e50b0f)
+++ molecuilder/src/UIElements/UIFactory.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -9,9 +9,9 @@
 #include <cassert>
 #include "Patterns/Singleton_impl.hpp"
-#include "UIElements/UIFactory.hpp"
+#include "UIFactory.hpp"
 
 // all factories that can be used:
-#include "UIElements/TextUIFactory.hpp"
-#include "UIElements/CommandLineUIFactory.hpp"
+#include "TextUI/TextUIFactory.hpp"
+#include "CommandLineUI/CommandLineUIFactory.hpp"
 
 UIFactory::UIFactory()
Index: molecuilder/src/UIElements/Views/MethodStringView.hpp
===================================================================
--- molecuilder/src/UIElements/Views/MethodStringView.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
+++ molecuilder/src/UIElements/Views/MethodStringView.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -0,0 +1,30 @@
+/*
+ * MethodStringView.hpp
+ *
+ *  Created on: Dec 14, 2009
+ *      Author: crueger
+ */
+
+#ifndef METHODSTRINGVIEW_HPP_
+#define METHODSTRINGVIEW_HPP_
+
+#include <boost/function.hpp>
+
+#include "Views/StringView.hpp"
+
+/**
+ * Wrapper to produce a StringView from any method that returns a String.
+ */
+class MethodStringView : public StringView
+{
+public:
+  MethodStringView(boost::function<std::string()>);
+  virtual ~MethodStringView();
+
+  virtual const std::string toString();
+
+private:
+  boost::function<std::string()> displayMethod;
+};
+
+#endif /* METHODSTRINGVIEW_HPP_ */
Index: molecuilder/src/UIElements/Views/StreamStringView.cpp
===================================================================
--- molecuilder/src/UIElements/Views/StreamStringView.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
+++ molecuilder/src/UIElements/Views/StreamStringView.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -0,0 +1,27 @@
+/*
+ * StreamStringView.cpp
+ *
+ *  Created on: Dec 14, 2009
+ *      Author: crueger
+ */
+
+#include <sstream>
+#include <iostream>
+
+#include "StreamStringView.hpp"
+
+using namespace std;
+
+StreamStringView::StreamStringView(boost::function<void(ostream *)> _displayMethod) :
+StringView(),
+displayMethod(_displayMethod)
+{}
+
+StreamStringView::~StreamStringView()
+{}
+
+const string StreamStringView::toString() {
+  stringstream s;
+  displayMethod(dynamic_cast<ostream *>(&s));
+  return s.str();
+}
Index: molecuilder/src/UIElements/Views/StreamStringView.hpp
===================================================================
--- molecuilder/src/UIElements/Views/StreamStringView.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
+++ molecuilder/src/UIElements/Views/StreamStringView.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -0,0 +1,36 @@
+/*
+ * StreamStringView.hpp
+ *
+ *  Created on: Dec 14, 2009
+ *      Author: crueger
+ */
+
+#ifndef STREAMSTRINGVIEW_HPP_
+#define STREAMSTRINGVIEW_HPP_
+
+#include <boost/function.hpp>
+#include <iostream>
+
+#include "Views/StringView.hpp"
+
+/**
+ * Wrapper to produce a StringView from any method that uses a stream to display something.
+ *
+ * The function is called with a stringstream which then is turned into a string later.
+ *
+ * Caveat: Make sure the stream passed to the method is actually used. Some methods seem to use a stream parameter for
+ * legacy reasons. These methods internally use the "Log() << Verbose()" mechanism instead of the stream.
+ */
+class StreamStringView : public StringView
+{
+public:
+  StreamStringView(boost::function<void(std::ostream *)>);
+  virtual ~StreamStringView();
+
+  virtual const std::string toString();
+
+private:
+  boost::function<void(std::ostream *)> displayMethod;
+};
+
+#endif /* STREAMSTRINGVIEW_HPP_ */
Index: molecuilder/src/UIElements/Views/StringView.hpp
===================================================================
--- molecuilder/src/UIElements/Views/StringView.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
+++ molecuilder/src/UIElements/Views/StringView.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -0,0 +1,29 @@
+/*
+ * StringView.hpp
+ *
+ *  Created on: Dec 14, 2009
+ *      Author: crueger
+ */
+
+#ifndef STRINGVIEW_HPP_
+#define STRINGVIEW_HPP_
+
+#include <string>
+#include "Views/View.hpp"
+
+/**
+ * View to show something as a string
+ *
+ * This View is used by calling the toString method.
+ * This View does *not* use the observer pattern.
+ */
+class StringView : public View
+{
+public:
+  StringView();
+  virtual ~StringView();
+
+  virtual const std::string toString()=0;
+};
+
+#endif /* STRINGVIEW_HPP_ */
Index: molecuilder/src/UIElements/Views/View.hpp
===================================================================
--- molecuilder/src/UIElements/Views/View.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
+++ molecuilder/src/UIElements/Views/View.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -0,0 +1,23 @@
+/*
+ * View.h
+ *
+ *  Created on: Dec 14, 2009
+ *      Author: crueger
+ */
+
+#ifndef VIEW_H_
+#define VIEW_H_
+
+/**
+ * Base class for all Views
+ *
+ * TODO: is this really needed or helpfull at all?
+ */
+class View
+{
+public:
+  View();
+  virtual ~View();
+};
+
+#endif /* VIEW_H_ */
